#ifndef GENMANIP_STRUCT_H
#define GENMANIP_STRUCT_H

#include "gbGENOM.h"

/* maximal size of trajectories */
// Used to define the size of the poster position for TrackQ:
// 100 tics/seconde * 1 minute
#ifndef GENMANIP_POSITION_TRACK_MAX_SIZE
#define GENMANIP_POSITION_TRACK_MAX_SIZE 100*60*1
#endif

#ifndef GENMANIP_MAX_CONFIG_SIZE
#define GENMANIP_MAX_CONFIG_SIZE	100
#endif

typedef enum GENMANIP_ON_OFF_ENUM {
  GENMANIP_OFF = 0,
  GENMANIP_ON = 1
} GENMANIP_ON_OFF_ENUM;

typedef enum GENMANIP_COLLISION_STATE_ENUM {
  GENMANIP_COLLISION_FREE = 0,
  GENMANIP_COLLISION_COLLISION
} GENMANIP_COLLISION_STATE_ENUM;

typedef struct GENMANIP_COLLISION_STATE_STR {
  GENMANIP_ON_OFF_ENUM mode;
  GENMANIP_COLLISION_STATE_ENUM state;
} GENMANIP_COLLISION_STATE_STR;

typedef struct GENMANIP_POSITION_TRACK_STR {
  int nb_points;
  int flag; /* position to continue tracking */
  Gb_q6 errorMax;
  int lp[GENMANIP_POSITION_TRACK_MAX_SIZE];
  Gb_q6 positions[GENMANIP_POSITION_TRACK_MAX_SIZE];
} GENMANIP_POSITION_TRACK_STR;

typedef struct GENMANIP_POSITION_STR {
  int lp;
  Gb_q6 q;
} GENMANIP_POSITION_STR;


typedef struct GENMANIP_CONFIG {
  float q[GENMANIP_MAX_CONFIG_SIZE];
  unsigned int size;
} GENMANIP_CONFIG;

typedef struct GENMANIP_MOTION_STR {
  double q[GENMANIP_MAX_CONFIG_SIZE];
  double vq[GENMANIP_MAX_CONFIG_SIZE];
  double aq[GENMANIP_MAX_CONFIG_SIZE];
  int size;
} GENMANIP_MOTION_STR;

typedef struct GENMANIP_DOF {
  unsigned int index;
  float value;
} GENMANIP_DOF;


typedef struct GENMANIP_SET_POSITION_STR {
  GEN_STRING128 name;
  float x;
  float y;
  float z;
} GENMANIP_SET_POSITION_STR;

typedef struct GENMANIP_SET_ORIENTATION_STR {
  GEN_STRING128 name;
  float yaw;
  float pitch;
  float roll;
} GENMANIP_SET_ORIENTATION_STR;

typedef struct GENMANIP_SET_POSE_STR {
  GEN_STRING128 name;
  float x;
  float y;
  float z;
  float yaw;
  float pitch;
  float roll;
} GENMANIP_SET_POSE_STR;


#endif
